
public class VacuumAgent implements Agent
{
    class Location
    {
        private int x;
        private int y;

        public Location(int first, int second)
        {
            setX(first);
            setY(second);
        }

        public int getX()
        {
            return x;
        }

        public void setX(int x)
        {
            this.x = x;
        }

        public int getY()
        {
            return y;
        }

        public void setY(int y)
        {
            this.y = y;
        }
    }

    public VacuumEnvironment e;
    Location location;

    public void Agent()
    {
        // read in the environment
        e = new VacuumEnvironment();
        System.out.println("New agent environment created.");
        //        e = readEnvironment();
        System.out.println("Agent has read in the environment");
        System.out.println(e.getWidth() + " " + e.getHeight());
        // place the agent in a random location in the environment
        location = new Location((int) (Math.random() * e.getWidth()), (int) (Math.random() * e.getHeight())); 
    }

    public VacuumAgent()
    {
        this.Agent();
    }

    @Override
    public VacuumEnvironment readEnvironment()
    {
        return new VacuumEnvironment();
    }

    @Override
    public Decision makeDecision(Environment e)
    {
        Decision d = null;
        // Are there any dirty locations to visit?
        boolean stillDirty = false;
        for (int i=0; i<((VacuumEnvironment)e).getHeight(); i++)
        {
            for (int j=0; j<((VacuumEnvironment)e).getWidth(); j++)
            {
                System.out.print(((VacuumEnvironment)e).rooms[j][i]?"1 ":"0 ");
                stillDirty = stillDirty || ((VacuumEnvironment)e).rooms[j][i];
            }
            System.out.println();
        }
        // If there are dirty locations
        if (stillDirty)
        {
            // If my current location is dirty, clean it
            if (((VacuumEnvironment)e).rooms[location.getX()][location.getY()])
                d = new VacuumDecision("clean");
            // Otherwise move randomly
            else
            {
                int move = (int) (Math.random()*4);
                switch (move)
                {
                    case 0: 
                        d = new VacuumDecision("left"); break;
                    case 1:
                        d = new VacuumDecision("right"); break;
                    case 2:
                        d = new VacuumDecision("up"); break;
                    case 3:
                        d = new VacuumDecision("down"); break;
                }
            }
        }
        // If not, I'm done
        else
            d = new VacuumDecision("nothing");
        System.out.println("Decision: " + ((VacuumDecision)d).action);
        return d;
    }

    @Override
    public void takeAction(Decision a)
    {
        // Try to do whatever the decision was
        switch (((VacuumDecision)a).action)
        {
            case CLEAN:
                e.rooms[location.getX()][location.getY()] = false;
                System.out.println("Action: cleaned");
                break;
            case MOVE_LEFT:
                if (location.getX() > 0)
                {
                    location.setX(location.getX() - 1);
                    System.out.println("Action: Moved left");
                }
                break;
            case MOVE_RIGHT:
                if (location.getX() < e.getWidth() - 1)
                {
                    location.setX(location.getX() + 1);
                    System.out.println("Action: Moved right");
                }
                break;
            case MOVE_DOWN:
                if (location.getY() < e.getHeight() - 1)
                {
                    location.setY(location.getY() + 1);
                    System.out.println("Action: Moved down");
                }
                break;
            case MOVE_UP:
                if (location.getY() > 0)
                {
                    location.setY(location.getY() - 1);
                    System.out.println("Action: Moved up");
                }
                break;
        }

    }
}

